const path = require("path");
const { CheckerPlugin } = require("awesome-typescript-loader");
const { TsConfigPathsPlugin } = require("awesome-typescript-loader");
const CopyWebpackPlugin = require("copy-webpack-plugin");
const CleanWebpackPlugin = require("clean-webpack-plugin");

module.exports = {
    entry: "./src/ts/bootstrap.ts",
    output: {
        filename: "./dist/app.bundle.js",
        path: path.resolve(__dirname, "."),
        publicPath: "./"
    },
    node: {
        fs: "empty",
        module: "empty"
    },
    resolve: {
        extensions: [
            ".ts",
            ".js"
        ]
    },
    devtool: "source-map",
    module: {
        rules: [
            {
                test: /\.ts$/,
                loader: "awesome-typescript-loader"
            }
        ]
    },
    plugins: [
        new CleanWebpackPlugin(
            [
                "dist"
            ],
            {
                verbose: false,
                exclude: [
                    ".gitkeep"
                ]
            }
        ),
        new CheckerPlugin(),
        new TsConfigPathsPlugin(),
        new CopyWebpackPlugin(
            [
                {
                    context: "./src",
                    from: "**/*",
                    to: "./dist/",
                    ignore: [
                        "ts/**/*"
                    ]
                }
            ]
        )
    ]
};